unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, ComCtrls, Spin;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Reopen1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Window1: TMenuItem;
    BasicPortView1: TMenuItem;
    FullPortView1: TMenuItem;
    FileRegister1: TMenuItem;
    Stopwatch1: TMenuItem;
    ConfigRegisters1: TMenuItem;
    ControlRegisters1: TMenuItem;
    Shape1: TShape;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TRichEdit;
    RuntimeWarnings1: TMenuItem;
    Timer1: TTimer;
    CheckBox3: TCheckBox;
    Label1: TLabel;
    Stimulus1: TMenuItem;
    Reset1: TMenuItem;
    N2: TMenuItem;
    SavePositions1: TMenuItem;
    RestorePositions1: TMenuItem;
    ExternalInterrupt1: TMenuItem;
    PowerOn1: TMenuItem;
    ExternalRTCC1: TMenuItem;
    procedure BasicPortView1Click(Sender: TObject);
    procedure FullPortView1Click(Sender: TObject);
    procedure FileRegister1Click(Sender: TObject);
    procedure Stopwatch1Click(Sender: TObject);
    procedure ControlRegisters1Click(Sender: TObject);
    procedure ConfigRegisters1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Reopen1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RuntimeWarnings1Click(Sender: TObject);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure SavePositions1Click(Sender: TObject);
    procedure RestorePositions1Click(Sender: TObject);
    procedure ExternalInterrupt1Click(Sender: TObject);
    procedure PowerOn1Click(Sender: TObject);
    procedure ExternalRTCC1Click(Sender: TObject);
  private
    { Private declarations }
    procedure add_ipc( value: integer );
    function  bin5( n1: integer ): string;
    function  bin8( n1: integer ): string;
    function  hex2( n1: integer ): string;
    function  hex3( n1: integer ): string;
    procedure highlight_current;
    procedure load_pm;
    procedure one_inst;
    procedure opcode_addwf( p1, p2: integer );
    procedure opcode_andlw( p1, p2: integer );
    procedure opcode_andwf( p1, p2: integer );
    procedure opcode_bank( p1, p2: integer );
    procedure opcode_bcf( p1, p2: integer );
    procedure opcode_bsf( p1, p2: integer );
    procedure opcode_btfsc( p1, p2: integer );
    procedure opcode_btfss( p1, p2: integer );
    procedure opcode_call( p1, p2: integer );
    procedure opcode_clrf( p1, p2: integer );
    procedure opcode_clrw( p1, p2: integer );
    procedure opcode_clrwdt( p1, p2: integer );
    procedure opcode_decf( p1, p2: integer );
    procedure opcode_decfsz( p1, p2: integer );
    procedure opcode_goto( p1, p2: integer );
    procedure opcode_incf( p1, p2: integer );
    procedure opcode_incfsz( p1, p2: integer );
    procedure opcode_iorlw( p1, p2: integer );
    procedure opcode_iorwf( p1, p2: integer );
    procedure opcode_iread( p1, p2: integer );
    procedure opcode_mode( p1, p2: integer );
    procedure opcode_movfw( p1, p2: integer );
    procedure opcode_movlw( p1, p2: integer );
    procedure opcode_movmw( p1, p2: integer );
    procedure opcode_movwf( p1, p2: integer );
    procedure opcode_movwm( p1, p2: integer );
    procedure opcode_movwo( p1, p2: integer );
    procedure opcode_nop( p1, p2: integer );
    procedure opcode_notf( p1, p2: integer );
    procedure opcode_page( p1, p2: integer );
    procedure opcode_reti( p1, p2: integer );
    procedure opcode_retiw( p1, p2: integer );
    procedure opcode_retlw( p1, p2: integer );
    procedure opcode_retp( p1, p2: integer );
    procedure opcode_return( p1, p2: integer );
    procedure opcode_rlf( p1, p2: integer );
    procedure opcode_rrf( p1, p2: integer );
    procedure opcode_sleep( p1, p2: integer );
    procedure opcode_subwf( p1, p2: integer );
    procedure opcode_swapf( p1, p2: integer );
    procedure opcode_testf( p1, p2: integer );
    procedure opcode_tris( p1, p2: integer );
    procedure opcode_xorlw( p1, p2: integer );
    procedure opcode_xorwf( p1, p2: integer );
    procedure poweron;
    function  read_ram( address: integer ): integer;
    procedure tick;
    function  unhex( c: char ): integer;
    procedure warning( msg: string );
    procedure write_ram( address, value: integer );
  public
    { Public declarations }
    procedure UpdateSpeed;
  end;

var
  Form1: TForm1;

implementation

uses Unit3, Unit4, Unit6, Unit7, Unit5, Unit2, Unit8, Unit9, Unit10;

{$R *.DFM}


{ global variables }
{ program memory, broken into procedure tags, p1, p2 }
var
   pm_raw: array [0..2047] of integer;
   pm_opcode: array [0..2047] of integer;
   pm_p1: array [0..2047] of integer;
   pm_p2: array [0..2047] of integer;
   pm_Break: array [0..2047] of boolean;
   pm_SelStart: array [0..2047] of integer;
   pm_LineStart: array [0..2047] of integer;
   pm_SelLength: array [0..2047] of integer;
   ipc: integer;

{ variable memory }
   w: integer;
   ram: array[0..255] of integer;
   ram_bank: integer;

{ special registers, and/or booleans therein }
   status: integer;
   pm_page: integer;
   status_TO: boolean;
   status_PD: boolean;
   status_Z: boolean;
   status_DC: boolean;
   status_C: boolean;

   option: integer;
   option_rtw: boolean;
   option_rte_ie: boolean;
   option_rts: boolean;
   option_rte_es: boolean;
   option_psa: boolean;
   option_prescalar: integer;

   rtcc_scale: integer;
   rtcc_count: integer;
   wdt_current: extended;
   wdt_limit: extended;
   wdt_count: integer;
   wdt_scale: integer;

   interrupt_pin: boolean;
   interrupt_rtcc: boolean;
   interrupt_wdt: boolean;
   in_interrupt: boolean;
   in_sleep: boolean;

   fuse: integer;
   fuse_turbo: boolean;
   fuse_sync: boolean;
   fuse_optionx: boolean;
   fuse_stackx: boolean;
   fuse_irc: boolean;
   fuse_cp: boolean;
   fuse_wdte: boolean;

   fusex: integer;
   fusex_cf: boolean;
   fusex_bor: boolean;
   fusex_ram: integer;
   fusex_mem: integer;

   { fake wall time }
   total_cycles: integer;
   total_seconds: real;
   seconds_per_cycle: real;

   mode: integer;
   DIR_A: integer;
   DIR_B: integer;
   DIR_C: integer;

   listfilename: string;

   opcodename: array [0..44] of string;
   speedname: array [0..7] of string;
   bitmasks: array [0..7] of integer;

   { these help identify port reads from the current instruction overlapping port writes from the last instruction}
   last_port_write: integer;
   port_write: integer;

   stack: array [1..8] of integer;
   stackidx: integer;
   stackend: integer;
   i_w: integer;
   i_fsr: integer;
   i_status: integer;

   istack: array [1..8] of integer;
   istackidx: integer;
   istackend: integer;

   RunStatus: integer;
   RunToIpc: integer;

   redram: array [1..10] of integer;
   rridx: integer;

   clk_oscs: LongInt;
   clk_inst: LongInt;
   clk_secs: Extended;
   SecondsPerOsc: Extended;

{ custom-written procedures }


procedure TForm1.add_ipc( value: integer );
var
   v1, v2: integer;
begin
   ipc := ( ipc + value ) mod 2048;
   ram[2] := ipc and 255;
   Form5.Hex_IPC.caption := hex3(ipc);
   Form5.Hex_PC.Caption := hex2(ram[2]);
end;


function TForm1.bin5( n1: integer ): string;
var
   v1, v2: integer;
   s1: string;
begin
   s1 := '';
   v1 := n1 and 31;
   v2 := 16;
   while v2 > 0 do
      begin
         if v1 >= v2 then
            begin
               v1 := v1 - v2;
               s1 := s1 + '1';
            end
         else
            begin
               s1 := s1 + '0';
            end;
         v2 := v2 div 2;
      end;
   bin5 := s1;
end;


function TForm1.bin8( n1: integer ): string;
var
   v1, v2: integer;
   s1: string;
begin
   s1 := '';
   v1 := n1 and 255;
   v2 := 128;
   while v2 > 0 do
      begin
         if v1 >= v2 then
            begin
               v1 := v1 - v2;
               s1 := s1 + '1';
            end
         else
            begin
               s1 := s1 + '0';
            end;
         v2 := v2 div 2;
      end;
   bin8 := s1;
end;


function TForm1.hex2( n1: integer ): string;
var
   v1, v2, v3: integer;
   s1, s2: string;
begin
   v1 := n1 and 255;
   v2 := n1 div 16;
   v3 := n1 mod 16;
   s1 := '';
   if v2 < 10 then
      s1 := s1 + chr(ord('0') + v2)
   else
      s1 := s1 + chr(ord('A') + v2 - 10);
   if v3 < 10 then
      s1 := s1 + chr(ord('0') + v3)
   else
      s1 := s1 + chr(ord('A') + v3 - 10);
   hex2 := s1;
end;


function TForm1.hex3( n1: integer ): string;
var
   v1, v2, v3, v4: integer;
   s1: string;
begin
   v1 := n1 and 4095;
   v2 := n1 div 256;
   v3 := ( n1 div 16 ) mod 16;
   v4 := n1 mod 16;
   s1 := '';
   if v2 < 10 then
      s1 := s1 + chr(ord('0') + v2)
   else
      s1 := s1 + chr(ord('A') + v2 - 10);
   if v3 < 10 then
      s1 := s1 + chr(ord('0') + v3)
   else
      s1 := s1 + chr(ord('A') + v3 - 10);
   if v4 < 10 then
      s1 := s1 + chr(ord('0') + v4)
   else
      s1 := s1 + chr(ord('A') + v4 - 10);
   hex3 := s1;
end;

procedure TForm1.highlight_current;
begin
   if pm_opcode[ipc] > 0 then
      begin
         Memo1.SelStart := pm_SelStart[ipc] + pm_SelLength[ipc];
         Memo1.SelLength := pm_SelLength[ipc] * -1;
         Label1.Caption := opcodename[pm_opcode[ipc]]
            + ' $' + hex2(pm_p1[ipc])
            + ', $' + hex2(pm_p2[ipc]);
      end;
end;


procedure TForm1.load_pm;
var
   F: TextFile;
   s1, s2: string;
   v1, v2, v3, v4, i1, i2, i3, lineno: integer;
   pass2: boolean;
begin
   Button1.Enabled := true;
   Button2.Enabled := true;
   Button3.Enabled := true;
   Button4.Enabled := true;
   CheckBox3.Enabled := true;
   Memo1.Visible := false;
   ipc := 0;
   while ipc < 2048 do
      begin
         pm_opcode[ipc] := 0;
         pm_raw[ipc] := 4095;
         pm_break[ipc] := false;
         ipc := ipc + 1;
      end;
   Memo1.Clear;
   { default values for fuse and fusex, in case they aren't specified }
   { FUSE default = all 1s }
   fuse_turbo := true;
   Form2.fuse_turbo_flag.font.color := clRed;
   fuse_sync := true;
   Form2.fuse_sync_flag.font.color := clRed;
   fuse_optionx := true;
   Form2.fuse_optionx_flag.font.color := clRed;
   fuse_stackx := true;
   stackend := 2;
   Form2.fuse_stackx_flag.font.color := clRed;
   fuse_irc := true;
   Form2.fuse_irc_flag.font.color := clRed;
   Form2.fuse_speed.caption := 'n/a';
   Form7.Edit4.Enabled := true;
   Form7.RadioButton1.Enabled := true;
   Form7.RadioButton2.Enabled := true;
   if Form7.Edit4.Text = ' ' then
      begin
         Form7.Edit4.Text := '50';
         Form7.RadioButton1.Checked := true;
         Form7.RadioButton2.Checked := false;
         updatespeed();
      end;
   Form2.fuse_osc.caption := 'RC';
   fuse_cp := true;
   Form2.fuse_cp_flag.font.color := clRed;
   fuse_wdte := true;
   Form2.fuse_wdte_flag.font.color := clRed;
   { FUSEX default to all 1s }
   fusex_cf := true;
   Form2.fusex_cf_flag.font.color := clRed;
   Form2.fusex_bor_flag.font.color := clRed;
   Form2.fusex_ram.caption := '3';
   Form2.fusex_mem.caption := '3';
   { *** }
   AssignFile(F, listfilename);
   Reset(F);
   pass2 := false;
   while not Eof(F) do
      begin
         ReadLn(F, s1);
         if s1 = 'Pass 2: assemble opcodes' then
            begin
               pass2 := true;
               continue;
            end;
         if s1 = 'EQUATED VALUES:' then
            pass2 := false;
         if pass2 = false then
            continue;
         if length(s1) < 15 then
            continue;
         if s1[5] = ':' then { decipher opcode and parms }
            begin
               ipc := (unhex(s1[1]) * 4096) + (unhex(s1[2]) * 256) + (unhex(s1[3]) * 16) + unhex(s1[4]);
               i1 := (unhex(s1[6]) * 4096) + (unhex(s1[7]) * 256) + (unhex(s1[8]) * 16) + unhex(s1[9]);
               if ( ipc < 2048 ) and ( ipc > -1 ) then
                  pm_raw[ipc] := i1 and 4095;
               if ipc = $FFF then { location for FUSE }
                  begin
                     fuse := i1;
                     if ( fuse and $800 ) = $800 then
                        begin
                           fuse_turbo := true;
                           Form2.fuse_turbo_flag.font.color := clRed;
                        end
                     else
                        begin
                           fuse_turbo := false;
                           Form2.fuse_turbo_flag.font.color := clBlack;
                        end;
                     if ( fuse and $400 ) = $400 then
                        begin
                           fuse_sync := true;
                           Form2.fuse_sync_flag.font.color := clRed;
                        end
                     else
                        begin
                           fuse_sync := false;
                           Form2.fuse_sync_flag.font.color := clBlack;
                        end;
                     if ( fuse and $200 ) = $200 then
                        begin
                           fuse_optionx := true;
                           Form2.fuse_optionx_flag.font.color := clRed;
                        end
                     else
                        begin
                           fuse_optionx := false;
                           Form2.fuse_optionx_flag.font.color := clBlack;
                        end;
                     if ( fuse and $100 ) = $100 then
                        begin
                           fuse_stackx := true;
                           stackend := 2;
                           Form2.fuse_stackx_flag.font.color := clRed;
                        end
                     else
                        begin
                           fuse_stackx := false;
                           stackend := 8;
                           Form2.fuse_stackx_flag.font.color := clBlack;
                        end;
                     if ( fuse and $080 ) = $80 then
                        begin
                           fuse_irc := true;
                           Form2.fuse_irc_flag.font.color := clRed;
                           Form2.fuse_speed.caption := 'n/a';
                           Form7.Edit4.Enabled := true;
                           Form7.RadioButton1.Enabled := true;
                           Form7.RadioButton2.Enabled := true;
                           if Form7.Edit4.Text = ' ' then
                              begin
                                 Form7.Edit4.Text := '50';
                                 Form7.RadioButton1.Checked := true;
                                 Form7.RadioButton2.Checked := false;
                              end;
                           updatespeed();
                           v4 := fuse and 3;
                           if v4 = 0 then
                              Form2.fuse_osc.caption := 'LP'
                           else
                           if v4 = 1 then
                              Form2.fuse_osc.caption := 'HS'
                           else
                           if v4 = 2 then
                              Form2.fuse_osc.caption := 'XT'
                           else
                              Form2.fuse_osc.caption := 'RC';
                        end
                     else
                        begin
                           fuse_irc := false;
                           Form2.fuse_irc_flag.font.color := clBlack;
                           v4 := ( fuse div 16 ) and 7;
                           Form2.fuse_speed.caption := speedname[v4];
                           if v4 = 0 then
                              begin
                                 Form7.Edit4.Text := '4';
                                 Form7.RadioButton1.Checked := true;
                                 Form7.RadioButton2.Checked := false;
                              end
                           else
                           if v4 = 1 then
                              begin
                                 Form7.Edit4.Text := '2';
                                 Form7.RadioButton1.Checked := true;
                                 Form7.RadioButton2.Checked := false;
                              end
                           else
                           if v4 = 2 then
                              begin
                                 Form7.Edit4.Text := '1';
                                 Form7.RadioButton1.Checked := true;
                                 Form7.RadioButton2.Checked := false;
                              end
                           else
                           if v4 = 3 then
                              begin
                                 Form7.Edit4.Text := '500';
                                 Form7.RadioButton1.Checked := false;
                                 Form7.RadioButton2.Checked := true;
                              end
                           else
                           if v4 = 4 then
                              begin
                                 Form7.Edit4.Text := '250';
                                 Form7.RadioButton1.Checked := false;
                                 Form7.RadioButton2.Checked := true;
                              end
                           else
                           if v4 = 5 then
                              begin
                                 Form7.Edit4.Text := '125';
                                 Form7.RadioButton1.Checked := false;
                                 Form7.RadioButton2.Checked := true;
                              end
                           else
                           if v4 = 6 then
                              begin
                                 Form7.Edit4.Text := '62.5';
                                 Form7.RadioButton1.Checked := false;
                                 Form7.RadioButton2.Checked := true;
                              end
                           else
                              begin
                                 Form7.Edit4.Text := '31.25';
                                 Form7.RadioButton1.Checked := false;
                                 Form7.RadioButton2.Checked := true;
                              end;
                           Form7.Edit4.Enabled := false;
                           Form7.RadioButton1.Enabled := false;
                           Form7.RadioButton2.Enabled := false;
                           UpdateSpeed();
                           Form2.FUSE_osc.Caption := '--';
                        end;
                     if ( fuse and $008 ) = $8 then
                        begin
                           fuse_cp := true;
                           Form2.fuse_cp_flag.font.color := clRed;
                        end
                     else
                        begin
                           fuse_cp := false;
                           Form2.fuse_cp_flag.font.color := clBlack;
                        end;
                     if ( fuse and $004 ) = $004 then
                        begin
                           fuse_wdte := true;
                           Form2.fuse_wdte_flag.font.color := clRed;
                        end
                     else
                        begin
                           fuse_wdte := false;
                           Form2.fuse_wdte_flag.font.color := clBlack;
                        end;
                  end
               else
               if ipc = $1FFF then { fake location for FUSEX }
                  begin
                     fusex := i1 and $7F;
                     if ( fusex and $40 ) = $40 then
                        begin
                           fusex_cf := true;
                           Form2.fusex_cf_flag.font.color := clRed;
                        end
                     else
                        begin
                           fusex_cf := false;
                           Form2.fusex_cf_flag.font.color := clBlack;
                        end;
                     if ( fusex and $30 ) = $30 then
                        Form2.fusex_bor_flag.font.color := clRed
                     else
                        Form2.fusex_bor_flag.font.color := clBlack;
                     v4 := ( fusex div 4 ) and 3;
                     Form2.fusex_ram.caption := IntToStr(v4);
                     v4 := fusex and 3;
                     Form2.fusex_mem.caption := IntToStr(v4);
                  end
               else
               if ( ipc < 0 ) or ( ipc > $7FF ) then
                  warning('illegal address found in load')
               else
               { determine opcode... }
               if i1 = 0 then { NOP }
                  begin
                     pm_opcode[ipc] := 01;
                     pm_p1[ipc] := 0;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= 2 ) and ( i1 <= 4 ) then { MOVWO, SLEEP, CLRWDT }
                  begin
                     pm_opcode[ipc] := i1;
                     pm_p1[ipc] := 0;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= 5 ) and ( i1 <= 7 ) then { TRIS }
                  begin
                     pm_opcode[ipc] := 5;
                     pm_p1[ipc] := i1;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= 12 ) and ( i1 <= 15 ) then { RETURN, RETP, RETI, RETIW }
                  begin
                     pm_opcode[ipc] := i1 - 6;
                     pm_p1[ipc] := 0;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $10 ) and ( i1 <= $17 ) then { PAGE }
                  begin
                     pm_opcode[ipc] := 10;
                     pm_p1[ipc] := i1 and 7;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $18 ) and ( i1 <= $1F ) then { BANK }
                  begin
                     pm_opcode[ipc] := 11;
                     pm_p1[ipc] := i1 and 7;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $20 ) and ( i1 <= $3F ) then { MOVWF }
                  begin
                     pm_opcode[ipc] := 12;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $40 ) and ( i1 <= $43 ) then { CLRW, IREAD, MOVWM, MOVMW }
                  begin
                     pm_opcode[ipc] := i1 - 51;
                     pm_p1[ipc] := 0;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $50 ) and ( i1 <= $5F ) then { MODE }
                  begin
                     pm_opcode[ipc] := 17;
                     pm_p1[ipc] := i1 and 15;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $60 ) and ( i1 <= $7F ) then { CLRF }
                  begin
                     pm_opcode[ipc] := 18;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $80 ) and ( i1 <= $BF ) then { SUBWF }
                  begin
                     pm_opcode[ipc] := 19;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $C0 ) and ( i1 <= $FF ) then { DECF }
                  begin
                     pm_opcode[ipc] := 20;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $100 ) and ( i1 <= $13F ) then { IORWF }
                  begin
                     pm_opcode[ipc] := 21;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $140 ) and ( i1 <= $17F ) then { ANDWF }
                  begin
                     pm_opcode[ipc] := 22;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $180 ) and ( i1 <= $1BF ) then { XORWF }
                  begin
                     pm_opcode[ipc] := 23;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $1C0 ) and ( i1 <= $1FF ) then { ADDWF }
                  begin
                     pm_opcode[ipc] := 24;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $200 ) and ( i1 <= $21F ) then { MOVFW }
                  begin
                     pm_opcode[ipc] := 25;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $220 ) and ( i1 <= $23F ) then { TESTF }
                  begin
                     pm_opcode[ipc] := 26;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $240 ) and ( i1 <= $27F ) then { NOTF }
                  begin
                     pm_opcode[ipc] := 27;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $280 ) and ( i1 <= $2BF ) then { INCF }
                  begin
                     pm_opcode[ipc] := 28;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $2C0 ) and ( i1 <= $2FF ) then { DECFSZ }
                  begin
                     pm_opcode[ipc] := 29;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $300 ) and ( i1 <= $33F ) then { RRF }
                  begin
                     pm_opcode[ipc] := 30;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $340 ) and ( i1 <= $37F ) then { RLF }
                  begin
                     pm_opcode[ipc] := 31;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $380 ) and ( i1 <= $3BF ) then { SWAPF }
                  begin
                     pm_opcode[ipc] := 32;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $3C0 ) and ( i1 <= $3FF ) then { INCFSZ }
                  begin
                     pm_opcode[ipc] := 33;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $01;
                  end
               else
               if ( i1 >= $400 ) and ( i1 <= $4FF ) then { BCF }
                  begin
                     pm_opcode[ipc] := 34;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $07;
                  end
               else
               if ( i1 >= $500 ) and ( i1 <= $5FF ) then { BSF }
                  begin
                     pm_opcode[ipc] := 35;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $07;
                  end
               else
               if ( i1 >= $600 ) and ( i1 <= $6FF ) then { BTFSC }
                  begin
                     pm_opcode[ipc] := 36;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $07;
                  end
               else
               if ( i1 >= $700 ) and ( i1 <= $7FF ) then { BTFSS }
                  begin
                     pm_opcode[ipc] := 37;
                     pm_p1[ipc] := i1 and 31;
                     pm_p2[ipc] := ( i1 div 32 ) and $07;
                  end
               else
               if ( i1 >= $800 ) and ( i1 <= $8FF ) then { RETLW }
                  begin
                     pm_opcode[ipc] := 38;
                     pm_p1[ipc] := i1 and 255;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $900 ) and ( i1 <= $9FF ) then { CALL }
                  begin
                     pm_opcode[ipc] := 39;
                     pm_p1[ipc] := i1 and 255;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $A00 ) and ( i1 <= $BFF ) then { GOTO }
                  begin
                     pm_opcode[ipc] := 40;
                     pm_p1[ipc] := i1 and 511;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $C00 ) and ( i1 <= $CFF ) then { MOVLW }
                  begin
                     pm_opcode[ipc] := 41;
                     pm_p1[ipc] := i1 and 255;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $D00 ) and ( i1 <= $DFF ) then { IORLW }
                  begin
                     pm_opcode[ipc] := 42;
                     pm_p1[ipc] := i1 and 255;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $E00 ) and ( i1 <= $EFF ) then { ANDLW }
                  begin
                     pm_opcode[ipc] := 43;
                     pm_p1[ipc] := i1 and 255;
                     pm_p2[ipc] := 0;
                  end
               else
               if ( i1 >= $F00 ) and ( i1 <= $FFF ) then { XORLW }
                  begin
                     pm_opcode[ipc] := 44;
                     pm_p1[ipc] := i1 and 255;
                     pm_p2[ipc] := 0;
                  end
               else
                  warning('invalid opcode bit pattern:' + hex3(i1));
               pm_SelStart[ipc] := Memo1.SelStart + 1;
               pm_SelLength[ipc] := Length(s1) - 15;
            end;
         s2 := Copy( s1, 16, Length(s1) - 15 );
         if ( Copy( s2, 1, 6 ) <> 'WARN: ' )
               and ( Copy( s2, 1, 7 ) <> 'ERROR: ' ) then
            Memo1.Lines.Add(' ' + s2);
      end;
   CloseFile(F);
   Memo1.Visible := true;
   ReOpen1.Visible := true;
   poweron();
   highlight_current();
end;


procedure TForm1.one_inst;
var
   op, p1, p2: integer;
begin
   last_port_write := port_write;
   port_write := 0;
   op := pm_opcode[ipc];
   p1 := pm_p1[ipc];
   p2 := pm_p2[ipc];
   while rridx > 1 do
      begin
         rridx := rridx - 1;
         Form6.Memo6.SelStart := redram[rridx];
         Form6.Memo6.SelLength := 2;
         Form6.Memo6.SelAttributes.Color := clBlack;
         Form6.Memo6.SelLength := 0;
      end;
   { quickest possible search: b-tree like... looks hideous, runs fast }
   if op < 32 then
      if op < 16 then
         if op < 8 then
            if op < 4 then
               if op < 2 then
                  if op = 0 then
                     begin
                        warning('program counter pointing to unprogrammed memory');
                        opcode_xorlw( 255, 0 );
                        RunStatus := 0;
                     end
                  else
                     opcode_nop(p1, p2)         { 01 }
               else
                  if op = 2 then
                     opcode_movwo(p1, p2)       { 02 }
                  else
                     opcode_sleep(p1, p2)       { 03 }
            else
               if op < 6 then
                  if op = 4 then
                     opcode_clrwdt(p1, p2)      { 04 }
                  else
                     opcode_tris(p1, p2)        { 05 }
               else
                  if op = 6 then
                     opcode_return(p1, p2)      { 06 }
                  else
                     opcode_retp(p1, p2)        { 07 }
         else
            if op < 12 then
               if op < 10 then
                  if op = 8 then
                     opcode_reti(p1, p2)        { 08 }
                  else
                     opcode_retiw(p1, p2)       { 09 }
               else
                  if op = 10 then
                     opcode_page(p1, p2)        { 10 }
                  else
                     opcode_bank(p1, p2)        { 11 }
            else
               if op < 14 then
                  if op = 12 then
                     opcode_movwf(p1, p2)       { 12 }
                  else
                     opcode_clrw(p1, p2)        { 13 }
               else
                  if op = 14 then
                     opcode_iread(p1, p2)       { 14 }
                  else
                     opcode_movmw(p1, p2)       { 15 }
      else
         if op < 24 then
            if op < 20 then
               if op < 18 then
                  if op = 16 then
                     opcode_movwm(p1, p2)       { 16 }
                  else
                     opcode_mode(p1, p2)        { 17 }
               else
                  if op = 18 then
                     opcode_clrf(p1, p2)        { 18 }
                  else
                     opcode_subwf(p1, p2)       { 19 }
            else
               if op < 22 then
                  if op = 20 then
                     opcode_decf(p1, p2)        { 20 }
                  else
                     opcode_iorwf(p1, p2)       { 21 }
               else
                  if op = 22 then
                     opcode_andwf(p1, p2)       { 22 }
                  else
                     opcode_xorwf(p1, p2)       { 23 }
         else
            if op < 28 then
               if op < 26 then
                  if op = 24 then
                     opcode_addwf(p1, p2)       { 24 }
                  else
                     opcode_movfw(p1, p2)       { 25 }
               else
                  if op = 26 then
                     opcode_testf(p1, p2)       { 26 }
                  else
                     opcode_notf(p1, p2)        { 27 }
            else
               if op < 30 then
                  if op = 28 then
                     opcode_incf(p1, p2)        { 28 }
                  else
                     opcode_decfsz(p1, p2)      { 29 }
               else
                  if op = 30 then
                     opcode_rrf(p1, p2)         { 30 }
                  else
                     opcode_rlf(p1, p2)         { 31 }
   else
      if op < 40 then
         if op < 36 then
            if op < 34 then
               if op = 32 then
                     opcode_swapf(p1, p2)       { 32 }
               else
                     opcode_incfsz(p1, p2)      { 33 }
            else
               if op = 34 then
                     opcode_bcf(p1, p2)         { 34 }
               else
                     opcode_bsf(p1, p2)         { 35 }
         else
            if op < 38 then
               if op = 36 then
                     opcode_btfsc(p1, p2)       { 36 }
               else
                     opcode_btfss(p1, p2)       { 37 }
            else
               if op = 38 then
                     opcode_retlw(p1, p2)       { 38 }
               else
                     opcode_call(p1, p2)        { 39 }
      else
         if op < 44 then
            if op < 42 then
               if op = 40 then
                     opcode_goto(p1, p2)        { 40 }
               else
                     opcode_movlw(p1, p2)       { 41 }
            else
               if op = 42 then
                     opcode_iorlw(p1, p2)       { 42 }
               else
                     opcode_andlw(p1, p2)       { 43 }
         else
                     opcode_xorlw(p1, p2);      { 44 }
   if interrupt_pin and (not in_interrupt) then
      begin
         { save registers }
         i_w := w;
         i_status := ram[3];
         i_fsr := ram[4];
         { take 5 ticks }
         tick();
         tick();
         tick();
         tick();
         tick();
         { save current program counter }
         istack[istackidx] := ipc;
         istackidx := istackidx + 1;
         { goto interrupt }
         ipc := 0;
         ram[2] := 0;
         Form5.hex_ipc.Caption := '000';
         Form5.hex_pc.Caption := '00';
         { set flags }
         interrupt_pin := false;
         in_interrupt := true;
      end;
   if interrupt_wdt and (not in_interrupt) then
      begin
         { save registers }
         i_w := w;
         i_fsr := ram[4];
         i_status := ram[3];
         { take 3 ticks }
         tick();
         tick();
         tick();
         { clear status.to }
         write_ram(3, Ram[3] and $EF);
         { reset timer }
         wdt_current := 0.0;
         wdt_count := 0;
         Form5.hex_wdt_count.caption := '00';
         { save current program counter }
         istack[istackidx] := ipc;
         istackidx := istackidx + 1;
         { goto reset }
         ipc := $7FF;
         ram[2] := $FF;
         Form5.hex_ipc.Caption := '7FF';
         Form5.hex_pc.Caption := 'FF';
         { give warning }
         warning('WATCHDOG TIMEOUT RESET');
         { set flags }
         interrupt_wdt := false;
         in_interrupt := true;
      end;
   if interrupt_rtcc and (not in_interrupt) then
      begin
         { save registers }
         i_w := w;
         i_fsr := ram[4];
         i_status := ram[3];
         { zero counter }
         rtcc_count := 0;
         Form5.hex_rtcc_count.Caption := '00';
         { take 3 ticks }
         tick();
         tick();
         tick();
         { save current program counter }
         istack[istackidx] := ipc;
         istackidx := istackidx + 1;
         { goto interrupt }
         ipc := 0;
         ram[2] := 0;
         Form5.hex_ipc.Caption := '000';
         Form5.hex_pc.Caption := '00';
         { give warning }
         warning('CLOCK/COUNTER ROLLOVER INTERRUPT');
         { set flags }
         interrupt_rtcc := false;
         in_interrupt := true;
      end;
   if CheckBox3.Checked or ( RunStatus < 2 ) then
      highlight_current();
end;


procedure TForm1.opcode_addwf( p1, p2: integer );
var
   v1, v2, c: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { total in the carry flag if its set and the fusex_cf flag is set }
   if ( fusex_cf = false ) and status_c then
      c := 1
   else
      c := 0;
   { set DC flag if rightmost nibbles total 10 or more }
   if ( ( v1 and 15 ) + ( read_ram(-1) and 15 ) + c ) > 9 then
      begin
         { set status.dc }
         status := status or 2;
      end
   else
      begin
         { clr status.dc }
         status := status and $FD;
      end;
   { perform operation }
   v2 := read_ram(-1) + v1 + c;
   { set Z flag if result = 0 }
   if v2 = 0 then
      begin
         { set status.z }
         status := status or 4;
      end
   else
      begin
         { clr status.z }
         status := status and $FB;
      end;
   { set carry flag if result > 255 }
   if v2 > 255 then
      begin
         { set status.c }
         status := status or 1;
         v2 := v2 and 255;
      end
   else
      begin
         { clr status.c }
         status := status and $FE;
      end;
   write_ram( 3, status );
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_andlw( p1, p2: integer );
var
   v1: integer;
begin
   { read file register }
   v1 := read_ram(-1) and p1;
   { set Z flag if result = 0 }
   if v1 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { update w }
   write_ram(-1, v1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_andwf( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := read_ram(-1) and v1;
   { set Z flag if result = 0 }
   if v2 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_bank( p1, p2: integer );
begin
   write_ram(4, ( ram[4] and $1F ) or ( p1 * 32 ) );
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_bcf( p1, p2: integer );
var
   v1, bitmask: integer;
begin
   bitmask := bitmasks[p2];
   { perform operation }
   v1 := read_ram(p1) or bitmask xor bitmask;
   { update back to file register }
   write_ram(p1, v1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_bsf( p1, p2: integer );
var
   v1, bitmask: integer;
begin
   bitmask := bitmasks[p2];
   { perform operation }
   v1 := read_ram(p1) or bitmask;
   { update back to file register }
   write_ram(p1, v1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_btfsc( p1, p2: integer );
var
   v1, bitmask: integer;
begin
   bitmask := bitmasks[p2];
   if ( read_ram(p1) and bitmask ) = 0 then
      begin
         add_ipc(2);
         tick();
         tick();
      end
   else
      begin
         add_ipc(1);
         tick();
      end;
end;


procedure TForm1.opcode_btfss( p1, p2: integer );
var
   v1, bitmask: integer;
begin
   bitmask := bitmasks[p2];
   if ( read_ram(p1) and bitmask ) > 0 then
      begin
         add_ipc(2);
         tick();
         tick();
      end
   else
      begin
         add_ipc(1);
         tick();
      end;
end;


procedure TForm1.opcode_call( p1, p2: integer );
begin
   if stackidx > stackend then
      begin
         warning('stack overflow');
         stackidx := 1;
      end;
   stack[stackidx] := ipc + 1;
   stackidx := stackidx + 1;
   { update IPC }
   ipc := ( ( pm_page and 3 ) * 512 ) or p1;
   Form5.hex_ipc.caption := hex3(ipc);
   { update PC }
   ram[2] := ipc mod 256;
   Form5.Hex_PC.Caption := hex2(ram[2]);
   { advance clock }
   tick();
   tick();
   if fuse_turbo = false then
      tick();
end;


procedure TForm1.opcode_clrf( p1, p2: integer );
begin
   write_ram( p1, 0 );
   { set status.z }
   write_ram( 3, status or 4 );
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_clrw( p1, p2: integer );
begin
   write_ram( -1, 0 );
   { set status.z }
   write_ram( 3, status or 4 );
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_clrwdt( p1, p2: integer );
begin
   { reset counter to 0 }
   wdt_current := 0.0;
   wdt_count := 0;
   Form5.hex_wdt_count.caption := '00';
   { set status.to and statusw.pd }
   write_ram(3, ram[3] or $18);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_decf( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := ( v1 + 255 ) mod 256;
   { set Z flag if result = 0 }
   if v2 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status or 4  xor 4 );
      end;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_decfsz( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := ( v1 + 255 ) mod 256;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   if v2 = 0 then
      begin
         add_ipc(2);
         tick();
         tick();
      end
   else
      begin
         add_ipc(1);
         tick();
      end;
end;


procedure TForm1.opcode_goto( p1, p2: integer );
begin
   { update IPC }
   ipc := ( ( pm_page and 3 ) * 512 ) or p1;
   Form5.hex_ipc.caption := hex3(ipc);
   { update PC }
   ram[2] := ipc mod 256;
   Form5.Hex_PC.Caption := hex2(ram[2]);
   { advance clock }
   tick();
   tick();
   if fuse_turbo = false then
      tick();
end;


procedure TForm1.opcode_incf( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := ( v1 + 1 ) mod 256;
   { set Z flag if result = 0 }
   if v2 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_incfsz( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := ( v1 + 1 ) mod 256;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   if v2 = 0 then
      begin
         add_ipc(2);
         tick();
         tick();
      end
   else
      begin
         add_ipc(1);
         tick();
      end;
end;


procedure TForm1.opcode_iorlw( p1, p2: integer );
var
   v1: integer;
begin
   { read file register, perform operation }
   v1 := read_ram(-1) or p1;
   { set Z flag if result = 0 }
   if v1 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { update w }
   write_ram(-1, v1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_iorwf( p1, p2: integer );
var
   v1: integer;
begin
   { read file register, perform operation }
   v1 := read_ram(p1) or read_ram(-1);
   { set Z flag if result = 0 }
   if v1 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v1)
   else
      write_ram(p1, v1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_iread( p1, p2: integer );
var
   idx, v1: integer;
begin
   if mode = -1 then
      begin
         warning('mode register read before being initialized');
         mode := 0;
      end;
   idx := ( ( mode and 7 ) * 256 ) + read_ram(-1);
   v1 := pm_raw[idx];
   write_ram(-1, v1 and 255);
   write_ram(-3, v1 div 256);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
   if fuse_turbo = false then
      begin
         tick();
         tick();
         tick();
      end;
end;


procedure TForm1.opcode_mode( p1, p2: integer );
begin
   write_ram( -3, p1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_movfw( p1, p2: integer );
var
   v1: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { set Z flag if result = 0 }
   if v1 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { write w }
   write_ram(-1, v1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_movlw( p1, p2: integer );
begin
   { set Z flag if result = 0 }
   if p1 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { write w }
   write_ram(-1, p1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_movmw( p1, p2: integer );
begin
   { write w }
   write_ram(-1, mode);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_movwf( p1, p2: integer );
var
   v1: integer;
begin
   { write w to file register }
   write_ram(p1, w);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_movwm( p1, p2: integer );
begin
   mode := read_ram(-1);
   Form5.hex_mode.caption := hex2(w);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_movwo( p1, p2: integer );
begin
   write_ram(-2, read_ram(-1));
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_nop( p1, p2: integer );
begin
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_notf( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := ( not v1 ) and 255;
   { set Z flag if result = 0 }
   if v2 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_page( p1, p2: integer );
begin
   { check for value too high }
   if p1 > 3 then
      warning('page > 3 specified, device only has pages 0-3');
   { update status }
   write_ram( 3, ( status and $1F ) or ( ( p1 and 3 ) * 32 ));
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_reti( p1, p2: integer );
begin
   istackidx := istackidx - 1;
   if istackidx < 1 then
      begin
         warning('interrupt stack underflow');
         istackidx := istackend;
      end;
   write_ram(-1, i_w);
   write_ram(3, i_status);
   write_ram(4, i_fsr);
   ipc := istack[istackidx];
   { advance clock }
   tick();
   tick();
   if fuse_turbo = false then
      tick();
end;


procedure TForm1.opcode_retiw( p1, p2: integer );
var
   v1: integer;
begin
   istackidx := istackidx - 1;
   if istackidx < 1 then
      begin
         warning('interrupt stack underflow');
         istackidx := istackend;
      end;
   write_ram(-1, i_w);
   write_ram(3, i_status);
   write_ram(4, i_fsr);
   ipc := istack[istackidx];
   { subtract w from RTCC, ignoring underflow }
   v1 := ( ram[2] + 512 - w ) mod 256;
   write_ram(2, v1);
   { advance clock }
   tick();
   tick();
   if fuse_turbo = false then
      tick();
end;


procedure TForm1.opcode_retlw( p1, p2: integer );
begin
   write_ram(-1, p1);
   stackidx := stackidx - 1;
   if stackidx < 1 then
      begin
         warning('stack underflow');
         stackidx := stackend;
      end;
   ipc := stack[stackidx];
   { advance clock }
   tick();
   tick();
   if fuse_turbo = false then
      tick();
end;


procedure TForm1.opcode_retp( p1, p2: integer );
begin
   stackidx := stackidx - 1;
   if stackidx < 1 then
      begin
         warning('stack underflow');
         stackidx := stackend;
      end;
   ipc := stack[stackidx];
   pm_page := ( ipc div 512 ) and 3;
   write_ram(3, ( status and $1F ) or ( pm_page * 32 ));
   { advance clock }
   tick();
   tick();
   if fuse_turbo = false then
      tick();
end;


procedure TForm1.opcode_return( p1, p2: integer );
begin
   stackidx := stackidx - 1;
   if stackidx < 1 then
      begin
         warning('stack underflow');
         stackidx := stackend;
      end;
   ipc := stack[stackidx];
   { advance clock }
   tick();
   tick();
   if fuse_turbo = false then
      tick();
end;


procedure TForm1.opcode_rlf( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := v1 * 2;
   if status_c then
      v2 := v2 or 1;
   { set carry flag if result > 255 }
   if v2 > 255 then
      begin
         { set status.c }
         write_ram( 3, status or 1 );
         v2 := v2 and 255;
      end
   else
      begin
         { clear status.c }
         write_ram( 3, status and $FE );
      end;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_rrf( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := v1 div 2;
   if status_c then
      v2 := v2 or $80;
   { set carry flag if result > 255 }
   if ( v1 and 1 ) = 1 then
      begin
         { set status.c }
         write_ram( 3, status or 1 );
      end
   else
      begin
         { clear status.c }
         write_ram( 3, status and $FE );
      end;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_sleep( p1, p2: integer );
begin
   if in_sleep = false then
      begin
         { set status.to, clear status.pd }
         write_ram(3, status and $F7 or $10);
         { clear watchdog timer counter }
         wdt_count := 0;
         Form5.Hex_wdt_count.Caption := '00';
         in_sleep := true;
      end;
   { advance clock }
   tick();
end;


procedure TForm1.opcode_subwf( p1, p2: integer );
var
   v1, v2, c, s: integer;
begin
   if ( fusex_cf = false ) and status_c then
      c := 1
   else
      c := 0;
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := v1 - read_ram(-1) - c;
   { set DC flag if rightmost nibbles total 10 or more }
   if ( ( v1 and 15 ) - ( read_ram(-1) and 15 ) - c ) < 0 then
      begin
         { clr status.dc }
         status := status and $FD;
      end
   else
      begin
         { set status.dc }
         status := status or 2;
      end;
   { set carry flag if result < 0 }
   if v2 < 0 then
      begin
         { clr status.c }
         status := status and $FE;
         v2 := ( v2 + 512 ) mod 256;
      end
   else
      begin
         { set status.c }
         status := status or 1;
      end;
   { set Z flag if result = 0 }
   if v2 = 0 then
      begin
         { set status.z }
         status := status or 4;
      end
   else
      begin
         { clr status.z }
         status := status and $FB;
      end;
   write_ram( 3, status );
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_swapf( p1, p2: integer );
var
   v1, v2: integer;
begin
   { read file register }
   v1 := read_ram(p1);
   { perform operation }
   v2 := ( ( v1 and 15 ) * 16 ) + ( v1 div 16 );
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v2)
   else
      write_ram(p1, v2);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_testf( p1, p2: integer );
begin
   { set Z flag if result = 0 }
   if read_ram(p1) = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end;
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_tris( p1, p2: integer );
begin
   if p1 = 5 then { Port A }
      begin
         if mode = $0F then { dir }
            begin
               Form3.hex_dira.caption := hex2(w);
               Form4.hex_dira.caption := hex2(w);
               Form3.bin_dira.caption := bin5(w);
               Form4.bin_dira.caption := bin5(w);
               dir_a := w;
            end
         else
         if mode = $0E then { plp }
            begin
               Form4.hex_plpa.caption := hex2(w);
               Form4.bin_plpa.caption := bin5(w);
            end
         else
         if mode = $0D then { lvl }
            begin
               Form4.hex_lvla.caption := hex2(w);
               Form4.bin_lvla.caption := bin5(w);
            end
         else
            warning('Port A only has registers for mode 13, 14 or 15')
      end
   else
   if p1 = 6 then { Port B }
      begin
         if mode = $0F then { dir }
            begin
               Form3.hex_dirb.caption := hex2(w);
               Form4.hex_dirb.caption := hex2(w);
               Form3.bin_dirb.caption := bin8(w);
               Form4.bin_dirb.caption := bin8(w);
               dir_b := w;
            end
         else
         if mode = $0E then { plp }
            begin
               Form4.hex_plpb.caption := hex2(w);
               Form4.bin_plpb.caption := bin8(w);
            end
         else
         if mode = $0D then { lvl }
            begin
               Form4.hex_lvlb.caption := hex2(w);
               Form4.bin_lvlb.caption := bin8(w);
            end
         else
         if mode = $0C then { st }
            begin
               Form4.hex_stb.caption := hex2(w);
               Form4.bin_stb.caption := bin8(w);
            end
         else
         if mode = $0B then { wken }
            begin
               Form4.hex_wkenb.caption := hex2(w);
               Form4.bin_wkenb.caption := bin8(w);
            end
         else
         if mode = $0A then { wked }
            begin
               Form4.hex_wkedb.caption := hex2(w);
               Form4.bin_wkedb.caption := bin8(w);
            end
         else
         if mode = $09 then { wkpnd }
            begin
               Form4.hex_wkpndb.caption := hex2(w);
               Form4.bin_wkpndb.caption := bin8(w);
            end
         else
         if mode = $08 then { cmp }
            begin
               Form4.hex_cmpb.caption := hex2(w);
               Form4.bin_cmpb.caption := bin8(w);
            end
         else
            warning('Port B only has registers for mode between 8 and 15')
      end
   else
   if p1 = 7 then { Port C }
      begin
         if mode = $0F then { dir }
            begin
               Form3.hex_dirc.caption := hex2(w);
               Form4.hex_dirc.caption := hex2(w);
               Form3.bin_dirc.caption := bin8(w);
               Form4.bin_dirc.caption := bin8(w);
               dir_c := w;
            end
         else
         if mode = $0E then { plp }
            begin
               Form4.hex_plpc.caption := hex2(w);
               Form4.bin_plpc.caption := bin8(w);
            end
         else
         if mode = $0D then { lvl }
            begin
               Form4.hex_lvlc.caption := hex2(w);
               Form4.bin_lvlc.caption := bin8(w);
            end
         else
         if mode = $0C then { st }
            begin
               Form4.hex_stc.caption := hex2(w);
               Form4.bin_stc.caption := bin8(w);
            end
         else
            warning('Port C only has registers for mode between 12 and 15')
      end
   else
      warning('TRIS can only have parm1 = 5, 6 or 7');
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_xorlw( p1, p2: integer );
var
   v1: integer;
begin
   { read file register, perform operation }
   v1 := read_ram(-1) xor p1;
   { set Z flag if result = 0 }
   if v1 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { update w }
   write_ram(-1, v1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.opcode_xorwf( p1, p2: integer );
var
   v1: integer;
begin
   { read file register, perform operation }
   v1 := read_ram(p1) xor read_ram(-1);
   { set Z flag if result = 0 }
   if v1 = 0 then
      begin
         { set status.z }
         write_ram( 3, status or 4 );
      end
   else
      begin
         { clr status.z }
         write_ram( 3, status and $FB );
      end;
   { update back to file register or w }
   if p2 = 0 then
      write_ram(-1, v1)
   else
      write_ram(p1, v1);
   { advance program counter... }
   add_ipc(1);
   { advance clock }
   tick();
end;


procedure TForm1.poweron;
var
   idx: integer;
begin
   stackidx := 1;
   stackend := 8;

   istackidx := 1;
   istackend := 1;

   pm_page := 0;
   ram_bank := 0;

   idx := 0;
   while idx < 256 do
      begin
         ram[idx] := -1;
         idx := idx + 1;
      end;
   Form5.Hex_RTCC.Caption := '--';
   Form6.Memo6.Lines.Clear;
   Form6.Memo6.Lines.Add('                        -- -- -- -- -- -- -- --');
   Form6.Memo6.Lines.Add('-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --');
   Form6.Memo6.Lines.Add('-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --');
   Form6.Memo6.Lines.Add('-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --');
   Form6.Memo6.Lines.Add('-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --');
   Form6.Memo6.Lines.Add('-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --');
   Form6.Memo6.Lines.Add('-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --');
   Form6.Memo6.Lines.Add('-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --');
   Form6.Memo6.Lines.Add('-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --');

   write_ram(2, $FF);
   write_ram(3, $18);
   write_ram(4, 0);
   write_ram(5, 0);
   write_ram(6, 0);
   write_ram(7, 0);
   Form5.Hex_w.Caption := '--';
   w := -1;
   write_ram(-3, $0F);
   write_ram(-2, $FF);
   ipc := $7FF;
   Form5.hex_ipc.Caption := '7FF';
   Form5.hex_pc.Caption := 'FF';

   rtcc_count := 0;
   rtcc_scale := 1;
   wdt_current := 0;
   wdt_limit := 0.018;
   wdt_count := 0;
   wdt_scale := 1;

   interrupt_pin := false;
   interrupt_rtcc := false;
   interrupt_wdt := false;
   in_interrupt := false;
   in_sleep := false;

end;


function TForm1.read_ram( address: integer ): integer;
var
   v1, value: integer;
begin
   if address > 7 then { GENERAL-PURPOSE RAM }
      begin
         if address > 15 then
            begin
               v1 := ( ram_bank * 32 ) + address;
               value := ram[v1];
            end
         else
            value := ram[address];
      end
   else
   if address = 7 then { PORTC }
      begin
         if last_port_write = 7 then
            if ( fuse_turbo = false ) and ( SecondsPerOsc < 0.000000028 ) then
               warning('high-speed port read/write overlap');
         value := ram[7] and DIR_C;
      end
   else
   if address = 6 then { PORTB }
      begin
         if last_port_write = 6 then
            if ( fuse_turbo = false ) and ( SecondsPerOsc < 0.000000028 ) then
               warning('high-speed port read/write overlap');
         value := ram[6] and DIR_B;
      end
   else
   if address = 5 then { PORTA }
      begin
         if last_port_write = 5 then
            if ( fuse_turbo = false ) and ( SecondsPerOsc < 0.000000028 ) then
               warning('high-speed port read/write overlap');
         value := ram[5] and DIR_A and 31;
      end
   else
   if ( address >= 1 ) and ( address <= 4 ) then { FSR, STATUS, PC, RTCC }
      begin
         value := ram[address];
      end
   else
   if address = 0 then { INDF }
      begin
         v1 := RAM[4];
         if v1 > 0 then
            value := read_ram( v1 )
         else
            begin
               warning('attempted to read INDF through INDF (FSR = 0)');
               value := 0;
            end;
      end
   else
   if address = -1 then { W }
      begin
         value := w;
      end
   else
   if address = -2 then { OPTION }
      begin
         value := option;
      end
   else
   if address = -3 then { MODE }
      begin
         value := mode;
      end
   else
      begin
         warning('illegal memory address ' + IntToStr(address));
         value := 0;
      end;
   if value < 0 then
      begin
         warning('read of uninitialized register');
         value := 0;
      end;
   read_ram := value;
end;


procedure TForm1.tick;
var
   v1: integer;
begin
   clk_inst := clk_inst + 1;
   if fuse_turbo then
      clk_oscs := clk_oscs + 4
   else
      clk_oscs := clk_inst;
   clk_secs := clk_oscs * SecondsPerOsc;
   Form7.Edit1.Text := IntToStr(clk_inst);
   Form7.Edit2.Text := IntToStr(clk_oscs);
   Form7.Edit3.Text := FloatToStr(clk_secs);
   if fuse_wdte then
      begin
         if fuse_turbo then
            wdt_current := wdt_current + SecondsPerOsc
         else
            wdt_current := wdt_current + ( SecondsPerOsc * 4.0 );
         if wdt_current > wdt_limit then
            begin
               wdt_count := wdt_count + 1;
               wdt_current := 0;
            end;
         if wdt_count >= wdt_scale then
            begin
               wdt_current := 0;
               wdt_count := 0;
               interrupt_wdt := true;
            end;
         Form5.hex_wdt_count.Caption := hex2(wdt_count);
      end;
   if option_rts = false then
      begin
         rtcc_count := rtcc_count + 1;
         if rtcc_count >= rtcc_scale then
            begin
               v1 := ram[1] + 1;
               if v1 > 255 then
                  begin
                     v1 := 0;
                     if option_rte_ie = false then
                        interrupt_rtcc := true;
                  end;
               write_ram(1, v1);
               rtcc_count := 0;
            end;
         Form5.hex_rtcc_count.Caption := hex2(rtcc_count);
      end;
end;


function TForm1.unhex( c: char ): integer;
begin
   if ( c >= '0' ) and ( c <= '9' ) then
      unhex := ord(c) - ord('0')
   else
      if ( c >= 'a' ) and ( c <= 'f' ) then
         unhex := ord(c) - ord('a') + 10
      else
         if ( c >= 'A' ) and ( c <= 'F' ) then
            unhex := ord(c) - ord('A') + 10
         else
            unhex := 0;
end;


procedure TForm1.warning( msg: string );
begin
   Form10.Memo10.Lines.Add( msg );
end;


procedure TForm1.write_ram( address, value: integer );
var
   v1, i1, i2: integer;
   s1: string;
begin
   if address > 7 then { GENERAL-PURPOSE RAM }
      begin
         if address > 15 then
            begin
               v1 := ( ram_bank * 32 ) + address;
               ram[v1] := value;
               i1 := ( ram_bank + 1 ) * 49;
               i2 := i1 + ( ( address - 16 ) * 3 );
            end
         else
            begin
               ram[address] := value;
               i2 := ( address * 3 );
            end;
         Form6.Memo6.SelStart := i2;
         Form6.Memo6.SelLength := 2;
         Form6.Memo6.SelText := hex2(value);
         if CheckBox3.Checked then
            begin
               Form6.Memo6.SelStart := i2;
               Form6.Memo6.SelLength := 2;
               Form6.Memo6.SelAttributes.Color := clRed;
               Form6.Memo6.SelLength := 0;
               redram[rridx] := i2;
               rridx := rridx + 1;
            end;
      end
   else
   if address = 7 then { PORTC }
      begin
         v1 := ram[7] and ( not DIR_C ) and value;
         ram[7] := v1;
         s1 := Hex2(v1);
         Form3.hex_portc.caption := s1;
         Form4.hex_portc.caption := s1;
         s1 := Bin8(v1);
         Form3.bin_portc.caption := s1;
         Form4.bin_portc.caption := s1;
         port_write := 7;
      end
   else
   if address = 6 then { PORTB }
      begin
         v1 := ram[6] and ( not DIR_B ) and value;
         ram[6] := v1;
         s1 := Hex2(v1);
         Form3.hex_portb.caption := s1;
         Form4.hex_portb.caption := s1;
         s1 := Bin8(v1);
         Form3.bin_portb.caption := s1;
         Form4.bin_portb.caption := s1;
         port_write := 6;
      end
   else
   if address = 5 then { PORTA }
      begin
         v1 := ram[5] and ( not DIR_A ) and value and 31;
         ram[5] := v1;
         s1 := Hex2(v1);
         Form3.hex_porta.caption := s1;
         Form4.hex_porta.caption := s1;
         s1 := Bin5(v1);
         Form3.bin_porta.caption := s1;
         Form4.bin_porta.caption := s1;
         port_write := 5;
      end
   else
   if address = 4 then { FSR }
      begin
         ram[4] := value;
         Form5.hex_fsr.caption := Hex2(value);
         ram_bank := value div 32;
         Form5.hex_bank.caption := IntToStr( ram_bank );
      end
   else
   if address = 3 then { STATUS }
      begin
         ram[3] := value;
         Form5.hex_status.caption := Hex2(value);
         v1 := value div 32;
         Form5.Hex_PAGE.Caption := IntToStr(v1);
         if ( value and 16 ) = 0 then
            begin
               Form5.status_to_flag.font.color := clBlack;
               status_to := false;
            end
         else
            begin
               Form5.status_to_flag.font.color := clRed;
               status_to := true;
            end;
         if ( value and 8 ) = 0 then
            begin
               Form5.status_pd_flag.font.color := clBlack;
               status_pd := false;
            end
         else
            begin
               Form5.status_pd_flag.font.color := clRed;
               status_pd := true;
            end;
         if ( value and 4 ) = 0 then
            begin
               Form5.status_z_flag.font.color := clBlack;
               status_z := false;
            end
         else
            begin
               Form5.status_z_flag.font.color := clRed;
               status_z := true;
            end;
         if ( value and 2 ) = 0 then
            begin
               Form5.status_dc_flag.font.color := clBlack;
               status_dc := false;
            end
         else
            begin
               Form5.status_dc_flag.font.color := clRed;
               status_dc := true;
            end;
         if ( value and 1 ) = 0 then
            begin
               Form5.status_c_flag.font.color := clBlack;
               status_c := false;
            end
         else
            begin
               Form5.status_c_flag.font.color := clRed;
               status_c := true;
            end;
      end
   else
   if address = 2 then { PC }
      begin
         ram[2] := value - 1;
         { specifically DOES NOT use the PAGE register... this is according to docs }
         ipc := ( ipc and $F00 ) or ( value - 1 );
         { question: does the PC still get incremented after you write to it? }
         { since only 1-tick instructions can MOV, ADD or SUB something to PC... }
         { why not just do the math, then subtract 1 from ipc... since you know }
         { the opcode will add one.  Also, do 3 compatible ticks or 2 turbo ticks  }
         { since it to takes 4 and 3 respectively, and the opcode will do one. }
         tick();
         tick();
         if fuse_turbo then
            tick();
      end
   else
   if address = 1 then { RTCC }
      begin
         if option_rtw = false then
            begin
               w := value;
               Form5.Hex_W.Caption := hex2(value);
            end;
         ram[1] := value;
         Form5.Hex_RTCC.caption := hex2(value);
      end
   else
   if address = 0 then { INDF }
      begin
         v1 := RAM[4];
         if v1 > 0 then
            write_ram( v1, value )
         else
            warning('attempted to write INDF through INDF (FSR = 0)');
      end
   else
   if address = -1 then { W }
      begin
         w := value;
         Form5.Hex_W.Caption := hex2(value);
         if option_rtw = false then
            begin
               ram[1] := value;
               Form5.Hex_RTCC.caption := hex2(value);
            end;
      end
   else
   if address = -2 then { OPTION }
      begin
         if fuse_optionx then
            option := value and $C0
         else
            option := value;
         Form5.Hex_OPTION.Caption := hex2(option);
         if option >= $80 then
            begin
               option_rtw := true;
               Form5.option_rtw_flag.font.color := clRed;
            end
         else
            begin
               option_rtw := false;
               Form5.option_rtw_flag.font.color := clBlack;
            end;
         if ( option and $40 ) > 0 then
            begin
               option_rte_ie := true;
               Form5.option_rteie_flag.font.color := clRed;
            end
         else
            begin
               option_rte_ie := false;
               Form5.option_rteie_flag.font.color := clBlack;
            end;
         if ( option and $20 ) > 0 then
            begin
               option_rts := true;
               Form5.option_rts_flag.font.color := clRed;
            end
         else
            begin
               option_rts := false;
               Form5.option_rts_flag.font.color := clBlack;
            end;
         if ( option and $10 ) > 0 then
            begin
               option_rte_es := true;
               Form5.option_rtees_flag.font.color := clRed;
            end
         else
            begin
               option_rte_es := false;
               Form5.option_rtees_flag.font.color := clBlack;
            end;
         if ( option and $08 ) > 0 then
            begin
               option_psa := true;
               Form5.option_psa_flag.font.color := clRed;
            end
         else
            begin
               option_psa := false;
               Form5.option_psa_flag.font.color := clBlack;
            end;
         option_prescalar := option and 7;
         Form5.option_prescalar.caption := IntToStr(option_prescalar);
         if option_psa then
            begin
               rtcc_scale := 1;
               wdt_scale := bitmasks[option_prescalar];
            end
         else
            begin
               rtcc_scale := 2 * bitmasks[option_prescalar];
               wdt_scale := 1;
            end;
         Form5.hex_wdt_scale.Caption := hex3(wdt_scale);
         Form5.hex_rtcc_scale.Caption := hex2(rtcc_scale);
      end
   else
   if address = -3 then { MODE }
      begin
         mode := value;
         Form5.hex_mode.Caption := hex2(value);
      end
   else
      warning('illegal memory address ' + IntToStr(address));
end;


procedure TForm1.UpdateSpeed;
var
   v1, v2, v3: Extended;
begin
   v1 := StrToFloat(Form7.Edit4.Text);
   if Form7.RadioButton1.Checked then
      SecondsPerOsc := 1 / ( v1 * 1000000 )
   else
      SecondsPerOsc := 1 / ( v1 * 1000 );
   clk_oscs := 0;
   clk_inst := 0;
   clk_secs := 0.0;
   Form7.Edit1.Text := '0';
   Form7.Edit2.Text := '0';
   Form7.Edit3.Text := '0.0';
end;


{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }
{ ************* GENERATED EVENT-RESPONSE ROUTINES ************** }

procedure TForm1.BasicPortView1Click(Sender: TObject);
begin
   if BasicPortView1.Checked then
      begin
         BasicPortView1.Checked := false;
         Form3.Visible := false;
      end
   else
      begin
         BasicPortView1.Checked := true;
         Form3.Visible := true;
      end;
end;

procedure TForm1.FullPortView1Click(Sender: TObject);
begin
   if FullPortView1.Checked then
      begin
         FullPortView1.Checked := false;
         Form4.Visible := false;
      end
   else
      begin
         FullPortView1.Checked := true;
         Form4.Visible := true;
      end;
end;

procedure TForm1.FileRegister1Click(Sender: TObject);
begin
   if FileRegister1.Checked then
      begin
         FileRegister1.Checked := false;
         Form6.Visible := false;
      end
   else
      begin
         FileRegister1.Checked := true;
         Form6.Visible := true;
      end;
end;

procedure TForm1.Stopwatch1Click(Sender: TObject);
begin
   if Stopwatch1.Checked then
      begin
         Stopwatch1.Checked := false;
         Form7.Visible := false;
      end
   else
      begin
         Stopwatch1.Checked := true;
         Form7.Visible := true;
      end;
end;

procedure TForm1.ControlRegisters1Click(Sender: TObject);
begin
   if ControlRegisters1.Checked then
      begin
         ControlRegisters1.Checked := false;
         Form5.Visible := false;
      end
   else
      begin
         ControlRegisters1.Checked := true;
         Form5.Visible := true;
      end;
end;

procedure TForm1.ConfigRegisters1Click(Sender: TObject);
begin
   if ConfigRegisters1.Checked then
      begin
         ConfigRegisters1.Checked := false;
         Form2.Visible := false;
      end
   else
      begin
         ConfigRegisters1.Checked := true;
         Form2.Visible := true;
      end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   opcodename[0]  := '???    ';
   opcodename[1]  := 'NOP    ';
   opcodename[2]  := 'MOVWO  ';
   opcodename[3]  := 'SLEEP  ';
   opcodename[4]  := 'CLRWDT ';
   opcodename[5]  := 'TRIS   ';
   opcodename[6]  := 'RETURN ';
   opcodename[7]  := 'RETP   ';
   opcodename[8]  := 'RETI   ';
   opcodename[9]  := 'RETIW  ';
   opcodename[10] := 'PAGE   ';
   opcodename[11] := 'BANK   ';
   opcodename[12] := 'MOVWF  ';
   opcodename[13] := 'CLRW   ';
   opcodename[14] := 'IREAD  ';
   opcodename[15] := 'MOVMW  ';
   opcodename[16] := 'MOVWM  ';
   opcodename[17] := 'MODE   ';
   opcodename[18] := 'CLRF   ';
   opcodename[19] := 'SUBWF  ';
   opcodename[20] := 'DECF   ';
   opcodename[21] := 'IORWF  ';
   opcodename[22] := 'ANDWF  ';
   opcodename[23] := 'XORWF  ';
   opcodename[24] := 'ADDWF  ';
   opcodename[25] := 'MOVFW  ';
   opcodename[26] := 'TESTF  ';
   opcodename[27] := 'NOTF   ';
   opcodename[28] := 'INCF   ';
   opcodename[29] := 'DECFSZ ';
   opcodename[30] := 'RRF    ';
   opcodename[31] := 'RLF    ';
   opcodename[32] := 'SWAPF  ';
   opcodename[33] := 'INCFSZ ';
   opcodename[34] := 'BCF    ';
   opcodename[35] := 'BSF    ';
   opcodename[36] := 'BTFSC  ';
   opcodename[37] := 'BTFSS  ';
   opcodename[38] := 'RETLW  ';
   opcodename[39] := 'CALL   ';
   opcodename[40] := 'GOTO   ';
   opcodename[41] := 'MOVLW  ';
   opcodename[42] := 'IORLW  ';
   opcodename[43] := 'ANDLW  ';
   opcodename[44] := 'XORLW  ';

   speedname[0] := '4 MHz  ';
   speedname[1] := '2 MHz  ';
   speedname[2] := '1 MHz  ';
   speedname[3] := '500 KHz';
   speedname[4] := '250 KHz';
   speedname[5] := '125 KHz';
   speedname[6] := '62 KHz ';
   speedname[7] := '31 KHz ';

   bitmasks[0] := $01;
   bitmasks[1] := $02;
   bitmasks[2] := $04;
   bitmasks[3] := $08;
   bitmasks[4] := $10;
   bitmasks[5] := $20;
   bitmasks[6] := $40;
   bitmasks[7] := $80;

   rridx := 1;

   RunStatus := 0;
   CheckBox3.Checked := true;
end;


procedure TForm1.Reopen1Click(Sender: TObject);
begin
   load_pm();
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
     begin
        listfilename := OpenDialog1.FileName;
        load_pm();
     end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   RunStatus := 1;
end;

procedure TForm1.RuntimeWarnings1Click(Sender: TObject);
begin
   if RuntimeWarnings1.Checked then
      begin
         RuntimeWarnings1.Checked := false;
         Form10.Visible := false;
      end
   else
      begin
         RuntimeWarnings1.Checked := true;
         Form10.Visible := true;
         Form10.Memo10.Clear;
      end;
end;

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   v1, v2, v3, idx: integer;
begin
   v1 := Memo1.SelStart;
   idx := 0;
   v2 := -1;
   while ( idx < 2048 ) and ( v2 < 0 ) do
      begin
         if ( v1 >= ( pm_SelStart[idx] ) )
               and ( v1 <= ( pm_SelStart[idx] + pm_SelLength[idx] ) ) then
            v2 := idx
         else
            idx := idx + 1;
      end;
   if v2 >= 0 then
      begin
         Memo1.SelStart := pm_SelStart[v2] + pm_SelLength[v2];
         Memo1.SelLength := pm_SelLength[v2] * -1;
         if pm_Break[v2] then
            begin
               pm_Break[v2] := false;
               Memo1.SelAttributes.Color := clBlack;
            end
         else
            begin
               pm_Break[v2] := true;
               Memo1.SelAttributes.Color := clRed;
            end;
         Memo1.SelLength := 0;
         Memo1.SelStart := pm_SelStart[ipc] + pm_SelLength[ipc];
         Memo1.SelLength := pm_SelLength[ipc] * -1;
      end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   if pm_opcode[ipc] = 39 then
      begin
         RunToIpc := ipc + 1;
         RunStatus := 2;
      end
   else
      RunStatus := 1;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   RunToIpc := ipc;
   RunStatus := 3;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   RunStatus := 0;
   highlight_current();
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   if RunStatus = 1 then { one instructon, then stop }
      begin
         one_inst();
         RunStatus := 0;
      end
   else
   if RunStatus = 2 then { run until ipc = RunToIpc }
      begin
         if ipc = RunToIpc then
            begin
               RunStatus := 0;
               highlight_current();
            end
         else
            one_inst();
      end
   else
   if RunStatus = 3 then { run until breakpoint }
      begin
         if pm_break[ipc] and ( ipc <> RunToIpc ) then
            begin
               RunStatus := 0;
               highlight_current();
            end
         else
            one_inst();
      end;
end;



procedure TForm1.Reset1Click(Sender: TObject);
begin
   ipc := $7FF;
   ram[2] := $FF;
   Form5.hex_ipc.caption := '7FF';
   Form5.Hex_PC.caption := 'FF';
   in_sleep := false;
   highlight_current();
end;

procedure TForm1.SavePositions1Click(Sender: TObject);
var
   F: TextFile;
begin
   AssignFile(F, 'c:\program files\scenix\sxsim.ini');
   Rewrite(F);
   WriteLn(F, '[windows]');
   WriteLn(F, IntToStr(Form1.Top) + ',' + IntToStr(Form1.Left) + ','
      + IntToStr(Form1.Width) + ',' + IntToStr(Form1.Height) );
   if Form2.Visible then
      WriteLn(F, IntToStr(Form2.Top) + ',' + IntToStr(Form2.Left) + ','
         + IntToStr(Form2.Width) + ',' + IntToStr(Form2.Height) )
   else
      WriteLn(F, '0,0,0,0');
   if Form3.Visible then
      WriteLn(F, IntToStr(Form3.Top) + ',' + IntToStr(Form3.Left) + ','
         + IntToStr(Form3.Width) + ',' + IntToStr(Form3.Height) )
   else
      WriteLn(F, '0,0,0,0');
   if Form4.Visible then
      WriteLn(F, IntToStr(Form4.Top) + ',' + IntToStr(Form4.Left) + ','
         + IntToStr(Form4.Width) + ',' + IntToStr(Form4.Height) )
   else
      WriteLn(F, '0,0,0,0');
   if Form5.Visible then
      WriteLn(F, IntToStr(Form5.Top) + ',' + IntToStr(Form5.Left) + ','
         + IntToStr(Form5.Width) + ',' + IntToStr(Form5.Height) )
   else
      WriteLn(F, '0,0,0,0');
   if Form6.Visible then
      WriteLn(F, IntToStr(Form6.Top) + ',' + IntToStr(Form6.Left) + ','
         + IntToStr(Form6.Width) + ',' + IntToStr(Form6.Height) )
   else
      WriteLn(F, '0,0,0,0');
   if Form7.Visible then
      WriteLn(F, IntToStr(Form7.Top) + ',' + IntToStr(Form7.Left) + ','
         + IntToStr(Form7.Width) + ',' + IntToStr(Form7.Height) )
   else
      WriteLn(F, '0,0,0,0');
   if Form10.Visible then
      WriteLn(F, IntToStr(Form10.Top) + ',' + IntToStr(Form10.Left) + ','
         + IntToStr(Form10.Width) + ',' + IntToStr(Form10.Height) )
   else
      WriteLn(F, '0,0,0,0');
   CloseFile(F);
end;

procedure TForm1.RestorePositions1Click(Sender: TObject);
var
   F: TextFile;
   v1, v2, v3, v4, v5: integer;
   s1, s2, s3, s4, s5: string;
begin
   AssignFile(F, 'c:\program files\scenix\sxsim.ini');
   Reset(F);
   ReadLn(F, s1);
   ReadLn(F, s1);
   v1 := Pos(',', s1);
   s2 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s3 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s4 := Copy(s1, 1, v1 - 1);
   s5 := Copy(s1, v1 + 1, Length(s1) - v1);
   v2 := StrToInt(s2);
   v3 := StrToInt(s3);
   v4 := StrToInt(s4);
   v5 := StrToInt(s5);
   Form1.Top := v2;
   Form1.Left := v3;
   Form1.Width := v4;
   Form1.Height := v5;

   { form2 }
   ReadLn(F, s1);
   v1 := Pos(',', s1);
   s2 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s3 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s4 := Copy(s1, 1, v1 - 1);
   s5 := Copy(s1, v1 + 1, Length(s1) - v1);
   v2 := StrToInt(s2);
   v3 := StrToInt(s3);
   v4 := StrToInt(s4);
   v5 := StrToInt(s5);
   if v2 = 0 then
      begin
         Form2.Visible := false;
         ConfigRegisters1.Checked := false;
      end
   else
      begin
         Form2.Top := v2;
         Form2.Left := v3;
         Form2.Width := v4;
         Form2.Height := v5;
         Form2.Visible := true;
         ConfigRegisters1.Checked := true;
      end;

   { form3 }
   ReadLn(F, s1);
   v1 := Pos(',', s1);
   s2 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s3 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s4 := Copy(s1, 1, v1 - 1);
   s5 := Copy(s1, v1 + 1, Length(s1) - v1);
   v2 := StrToInt(s2);
   v3 := StrToInt(s3);
   v4 := StrToInt(s4);
   v5 := StrToInt(s5);
   if v2 = 0 then
      begin
         Form3.Visible := false;
         BasicPortView1.Checked := false;
      end
   else
      begin
         Form3.Top := v2;
         Form3.Left := v3;
         Form3.Width := v4;
         Form3.Height := v5;
         Form3.Visible := true;
         BasicPortView1.Checked := true;
      end;

   { form4 }
   ReadLn(F, s1);
   v1 := Pos(',', s1);
   s2 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s3 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s4 := Copy(s1, 1, v1 - 1);
   s5 := Copy(s1, v1 + 1, Length(s1) - v1);
   v2 := StrToInt(s2);
   v3 := StrToInt(s3);
   v4 := StrToInt(s4);
   v5 := StrToInt(s5);
   if v2 = 0 then
      begin
         Form4.Visible := false;
         FullPortView1.Checked := false;
      end
   else
      begin
         Form4.Top := v2;
         Form4.Left := v3;
         Form4.Width := v4;
         Form4.Height := v5;
         Form4.Visible := true;
         FullPortView1.Checked := true;
      end;

   { form5 }
   ReadLn(F, s1);
   v1 := Pos(',', s1);
   s2 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s3 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s4 := Copy(s1, 1, v1 - 1);
   s5 := Copy(s1, v1 + 1, Length(s1) - v1);
   v2 := StrToInt(s2);
   v3 := StrToInt(s3);
   v4 := StrToInt(s4);
   v5 := StrToInt(s5);
   if v2 = 0 then
      begin
         Form5.Visible := false;
         ControlRegisters1.Checked := false;
      end
   else
      begin
         Form5.Top := v2;
         Form5.Left := v3;
         Form5.Width := v4;
         Form5.Height := v5;
         Form5.Visible := true;
         ControlRegisters1.Checked := true;
      end;

   { form6 }
   ReadLn(F, s1);
   v1 := Pos(',', s1);
   s2 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s3 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s4 := Copy(s1, 1, v1 - 1);
   s5 := Copy(s1, v1 + 1, Length(s1) - v1);
   v2 := StrToInt(s2);
   v3 := StrToInt(s3);
   v4 := StrToInt(s4);
   v5 := StrToInt(s5);
   if v2 = 0 then
      begin
         Form6.Visible := false;
         FileRegister1.Checked := false;
      end
   else
      begin
         Form6.Top := v2;
         Form6.Left := v3;
         Form6.Width := v4;
         Form6.Height := v5;
         Form6.Visible := true;
         FileRegister1.Checked := true;
      end;

   { form7 }
   ReadLn(F, s1);
   v1 := Pos(',', s1);
   s2 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s3 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s4 := Copy(s1, 1, v1 - 1);
   s5 := Copy(s1, v1 + 1, Length(s1) - v1);
   v2 := StrToInt(s2);
   v3 := StrToInt(s3);
   v4 := StrToInt(s4);
   v5 := StrToInt(s5);
   if v2 = 0 then
      begin
         Form7.Visible := false;
         StopWatch1.Checked := false;
      end
   else
      begin
         Form7.Top := v2;
         Form7.Left := v3;
         Form7.Width := v4;
         Form7.Height := v5;
         Form7.Visible := true;
         StopWatch1.Checked := true;
      end;

   { form10 }
   ReadLn(F, s1);
   v1 := Pos(',', s1);
   s2 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s3 := Copy(s1, 1, v1 - 1);
   s1 := Copy(s1, v1 + 1, Length(s1) - v1);
   v1 := Pos(',', s1);
   s4 := Copy(s1, 1, v1 - 1);
   s5 := Copy(s1, v1 + 1, Length(s1) - v1);
   v2 := StrToInt(s2);
   v3 := StrToInt(s3);
   v4 := StrToInt(s4);
   v5 := StrToInt(s5);
   if v2 = 0 then
      begin
         Form10.Visible := false;
         RunTimeWarnings1.Checked := false;
      end
   else
      begin
         Form10.Top := v2;
         Form10.Left := v3;
         Form10.Width := v4;
         Form10.Height := v5;
         Form10.Visible := true;
         RunTimeWarnings1.Checked := true;
      end;
   CloseFile(F);
end;

procedure TForm1.ExternalInterrupt1Click(Sender: TObject);
begin
   interrupt_pin := true;
   in_sleep := false;
end;

procedure TForm1.PowerOn1Click(Sender: TObject);
begin
   poweron();
end;

procedure TForm1.ExternalRTCC1Click(Sender: TObject);
var
   v1: integer;
begin
   if option_rts then
      begin
         rtcc_count := rtcc_count + 1;
         if rtcc_count >= rtcc_scale then
            begin
               v1 := ram[1] + 1;
               if v1 > 255 then
                  begin
                     v1 := 0;
                     if option_rte_ie = false then
                        interrupt_rtcc := true;
                  end;
               write_ram(1, v1);
               rtcc_count := 0;
            end;
         Form5.hex_rtcc_count.Caption := hex2(rtcc_count);
      end;
end;

end.
